{-
    Kaya - My favourite toy language.
    Copyright (C) 2004, 2005 Edwin Brady

    This file is distributed under the terms of the GNU General
    Public Licence. See COPYING for licence.
-}

module Errors where

import AbsSyntax

-- Represent errors as a datatype, so that they can be changed easily
-- TODO: Not used yet, but it would be nice if it was!

data Error = CantUnify Type Type
           | NotCasable Type
           | NotPrintable Type
           | UndefName Name
           | AmbiguousName Name [(Name, Type)]
           | PrivateName Name
           | TooManyArgs
           | CantForLoop Type
           | NeedTypeDecl Name
           | Unknown Field Name Type
           | IsVoid Name
           | CantDoOp Op Type Type
           | CantDoUnOp Op Type
           | CantCoerce Type Type
           | DataDefined Name
           | TypeDefined Name
           | FunDefined Name
           | DupField Name Name
           | NotAllReturn Name
           | NotParameter Type
           | UndeclaredTyVar Name
           | Undefype Name
           | GenericTypeError
           | InfiniteType
           | LessGeneral Type Type
